package com.ruoyi.web.base.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.framework.web.service.TokenService;
import com.ruoyi.web.base.domain.BaseMarket;
import com.ruoyi.web.base.service.IBaseMarketService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

import static com.ruoyi.common.core.domain.AjaxResult.success;
import static com.ruoyi.common.utils.SecurityUtils.getUsername;

/**
 * <p>
 * 市场 前端控制器
 * </p>
 *
 * @author author
 * @since 2026-02-03
 */
@RestController
@RequestMapping("/base-market")
public class BaseMarketController {

    @Autowired
    private IBaseMarketService baseMarketService;
    @Autowired
    private TokenService tokenService;

    @ApiOperation("市场管理添加")
    @PostMapping("/add")
    public AjaxResult add(@RequestBody BaseMarket baseMarket, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseMarketService.count(new QueryWrapper<BaseMarket>().eq("org_id",loginOrgId).eq("market_num", baseMarket.getMarketNum())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseMarket.setOrgId(loginOrgId);
        baseMarket.setCreateBy(getUsername());
        return success(baseMarketService.save(baseMarket));
    }

    @ApiOperation("市场管理修改")
    @PostMapping("/edit")
    public AjaxResult edit(@RequestBody BaseMarket baseMarket, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseMarketService.count(new QueryWrapper<BaseMarket>().ne("id",baseMarket.getId()).eq("org_id",loginOrgId).eq("marke_num", baseMarket.getMarketNum())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseMarket.setUpdateBy(getUsername());
        return success(baseMarketService.updateById(baseMarket));
    }

    @ApiOperation("市场管理删除")
    @PostMapping("/delete")
    public AjaxResult delete(@RequestBody Map<String, String> paramsMap) {
        String ids = paramsMap.get("ids");
        for (String s : ids.split(",")) {
            baseMarketService.removeById(s);
        }
        return success();
    }

    @ApiOperation("市场管理列表")
    @PostMapping("/list")
    public AjaxResult listAll( HttpServletRequest request){
        return success(baseMarketService.list(new QueryWrapper<BaseMarket>().eq("org_id",tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("市场管理分页")
    @GetMapping("/page")
    public AjaxResult page(@RequestParam("pageNum") Integer pageNum, @RequestParam("pageSize") Integer pageSize,HttpServletRequest request
    ) {
        return success(baseMarketService.page(new Page<BaseMarket>(pageNum,pageSize),new QueryWrapper<BaseMarket>().eq("org_id",tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("市场管理详情")
    @PostMapping("/listById")
    public AjaxResult listById(@RequestBody Map<String, String> paramsMap){
        String id = paramsMap.get("id");
        return success(baseMarketService.getById(id));
    }

}
